#
# Easysim::SimuLib.pm
#       - contents simulate classes for timeSimulator
#
# 12.12.2001: Martin Bbik <bobik@decef.elf.stuba.sk>
#
# TEAM-08-

use strict;
use warnings;

################################################
# class TModel
#
#
package TModel;


    sub new {
            my $proto = shift;
            my $class = ref($proto) || $proto;
            my $self  = {
                VarList       => undef,
                ConstList   => undef,
                ProcessList     => undef,
            };
            bless ($self, $class);
            return $self;
    }

    sub Load {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }
    

################################################
# class TProcess
#
#
package TProcess;

    sub new {
        my $proto = shift;
        my $class = ref($proto) || $proto;
        my $self  = {
            Class       => "PROCESS",
            Identity   => undef,
            SensList    => undef,
            SigList        => undef,
            VarList         => undef,
            ConstList   => undef,
            CmdList        => undef,
        };
        bless ($self, $class);
        return $self;
    }

    sub Load {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub Run {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }
    
################################################
# class TObject
#
#
package TObject;

    sub new {
        my $proto = shift;
        my $class = ref($proto) || $proto;
        my $self  = {
            Class       => "OBJECT",
            Identity   => undef,
            Kind    => undef,
            Type        => undef,
            Value         => undef,
            Event   => undef,
            SensList        => undef,
        };
        bless ($self, $class);
        return $self;
    }

    sub Load {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub Write {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub Read {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

################################################
# class TAssign
#
#
package TAssign;

    sub new {
        my $proto = shift;
        my $class = ref($proto) || $proto;
        my $self  = {
            Class       => "ASSIGN",
            Identity   => undef,
            Dest    => undef,
            ConstList        => undef,
            CmdTree         => undef,
        };
        bless ($self, $class);
        return $self;
    }

    sub Load {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub Run {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

################################################
# class TCondition
#
#
package TCondition;

    sub new {
        my $proto = shift;
        my $class = ref($proto) || $proto;
        my $self  = {
            Class       => "CONDITION",
            Identity   => undef,
            ConstList    => undef,
            CondList        => undef,
        };
        bless ($self, $class);
        return $self;
    }

    sub Load {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub Run {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }


################################################
# class TIfState
#
#
package TIfState;

    sub new {
        my $proto = shift;
        my $class = ref($proto) || $proto;
        my $self  = {
            Class       => "IFSTATE",
            Identity   => undef,
            ArrList    => undef,
        };
        bless ($self, $class);
        return $self;
    }

    sub Load {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub Run {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }


################################################
# class TCaseState
#
#
package TCaseState;

    sub new {
        my $proto = shift;
        my $class = ref($proto) || $proto;
        my $self  = {
            Class       => "CASESTATE",
            Identity   => undef,
            CaseVal    => undef,
            ArrList        => undef,
        };
        bless ($self, $class);
        return $self;
    }

    sub Load {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub Run {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }


################################################
# class TScheduler
#
#
package TScheduler;

    sub new {
        my $proto = shift;
        my $class = ref($proto) || $proto;
        my $self  = {
            SignalDriver       => undef,
            SimTime       => 0,
        };
        bless ($self, $class);
        return $self;
    }

    sub Add {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub GetNext {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }

    sub GetCurrTime {
        my $self = shift;
        if (@_) {
            print "\n$self->{Class} > Not supported in prototype !";
        }
        return $self->{Class};
    }
 
1;

#
# END Easysim::SimuLib.pm
#

