#!/usr/bin/perl

use strict;
use Easysim::Communication;
use Easysim::Message;
use Easysim::Utils;
use Easysim::XML;

# immediatelly print everything
STDOUT->autoflush(1);
STDERR->autoflush(1);

my %config=(
	"port-gui"		=>2467,
	"port-compiler"		=>2468,
	"port-simulator"	=>2469,
);
my $config=\%config;

my $kernel=new Easysim::Communication("client","localhost:$config->{'port-gui'}");

# get project ID
my $dom=message_newProject();
$kernel->send_message($dom);
my $dom=undef;;
do{
	$dom=$kernel->receive_message();
}while(not defined $dom or $dom eq "");
print "Replay:\n",$dom->toString,"\n";

# compile something
my $dom=message_compile();
$kernel->send_message($dom);
my $dom=undef;;
do{
	$dom=$kernel->receive_message();
}while(not defined $dom or $dom eq "");
print "Replay:\n",$dom->toString,"\n";


# compile something another
my $dom=message_compile();
$kernel->send_message($dom);
my $dom=undef;;
do{
	$dom=$kernel->receive_message();
}while(not defined $dom or $dom eq "");
print "Replay:\n",$dom->toString,"\n";



# simulate something
my $dom=message_simulate();
$kernel->send_message($dom);
my $dom=undef;;
do{
	$dom=$kernel->receive_message();
}while(not defined $dom or $dom eq "");
print "Replay:\n",$dom->toString,"\n";

# simulate something another
my $dom=message_simulate();
$kernel->send_message($dom);
my $dom=undef;;
do{
	$dom=$kernel->receive_message();
}while(not defined $dom or $dom eq "");
print "Replay:\n",$dom->toString,"\n";




sub message_compile
{
	print "\n\nSending message: compile\n";
	my $msg=qq~<?xml version="1.0" encoding="iso8859-2"?>
		<easysim>
			<project id="0">
				<commands>
					<command name="compile">
						<vhdlSource>
							...bla bla bla...
						</vhdlSource>
					</command>
				</commands>
			</project>
		</easysim>
	~;
	my $parser=Easysim::XML->new();
	my $dom=$parser->parse_string("$msg");
	return($dom);
}

sub message_newProject
{
	print "\n\nSending message: newProject\n";
	my $msg=qq~<?xml version="1.0" encoding="iso8859-2"?>
		<easysim>
			<project id="0">
				<commands>
					<command name="newProject"/>
				</commands>
			</project>
		</easysim>
	~;
	my $parser=Easysim::XML->new();
	my $dom=$parser->parse_string("$msg");
	return($dom);
}

sub message_simulate
{
	print "\n\nSending message: simulate\n";
	my $msg=qq~<?xml version="1.0" encoding="iso8859-2"?>
		<easysim>
			<project id="0">
				<commands>
					<command name="simulate"/>
				</commands>
			</project>
		</easysim>
	~;
	my $parser=Easysim::XML->new();
	my $dom=$parser->parse_string("$msg");
	return($dom);
}

